      module m_ECOSM_bioini

      contains

   
      Subroutine ECOSM_bioini

      use mod_xc
      use mod_necessary_ecovars, only : nsed, nbio

      implicit none
      include 'common_blocks.h'
      include 'biovar.h'
      include 'ECOSMparam1.h'



*********************************************************************** *


*  change units 1/day to 1/sec and mmolN,P,Si to mmolC
           BioC(1) =   PrmBioC(1) /sedy0                    !  1/day
           BioC(2) =   PrmBioC(2) /sedy0                    !  1/day
           BioC(3) =   PrmBioC(3)                           !  m**2/W
           BioC(4) =   PrmBioC(4)                           !  1/m
           BioC(5) =   PrmBioC(5)                         !  m**2/mgCHL
           BioC(6) =   PrmBioC(6)*PrmREDF(1)*PrmREDF(6)   !  mmolN/m**3
           BioC(7) =   PrmBioC(7)*PrmREDF(1)*PrmREDF(6)   !  mmolN/m**3
           BioC(8) =   PrmBioC(8)/(PrmREDF(1)*PrmREDF(6)) !  m**3/mmolN
           BioC(9) =   PrmBioC(9) /sedy0                    !  1/day
           BioC(10)=   PrmBioC(10)/sedy0                    !  1/day
           BioC(11)=   PrmBioC(11)/sedy0                    !  1/day
           BioC(12)=   PrmBioC(12)/sedy0                    !  1/day
           BioC(13)=   PrmBioC(13)/sedy0                    !  1/day
           BioC(14)=   PrmBioC(14)*PrmREDF(1)*PrmREDF(6)   !  mmolN/m**3
           BioC(15)=   PrmBioC(15)/sedy0                    !  1/day
           BioC(16)=   PrmBioC(16)/sedy0                    !  1/day
           BioC(17)=   PrmBioC(17)/sedy0                    !  1/day
           BioC(18)=   PrmBioC(18)/sedy0                    !  1/day
           BioC(19)=   PrmBioC(19)                          !  1
           BioC(20)=   PrmBioC(20)                          !  1
           BioC(21)=   PrmBioC(21)                          !  1

           BioC(22)=   PrmBioC(22)/sedy0                    !   1/day
           BioC(23)=   PrmBioC(23)/sedy0                    !   m/day
           BioC(24)=   PrmBioC(24)/sedy0                    !   m/day
* set as mmolN/m**3 =0.25  !!!! need a correction
           BioC(25)=   PrmBioC(25)*PrmREDF(2)*PrmREDF(6)   ! mmolP/m**3
           BioC(26)=   PrmBioC(26)*PrmREDF(3)*PrmREDF(6)   ! mmolSi/m**3
           BioC(27)=   PrmBioC(27)/sedy0                    !   1/day

           BioC(28)=   PrmBioC(28)/sedy0                    !  1/day

           BioC(29)=   PrmBioC(29)                          ! 1/degC
        
           BioC(30)=   PrmBioC(30)                         ! degC

           BioC(31)=   PrmBioC(31)/sedy0                   ! 1/d

           BioC(32)=   PrmBioC(32)/sedy0                   ! 1/d

           BioC(33)=   PrmBioC(33)/sedy0                   ! m/d
           
           BioC(34)=   PrmBioC(34)                         !  N/m**2

           BioC(35)=   PrmBioC(35)/sedy0                   ! 1/day
        
           BioC(36)=   PrmBioC(36)/sedy0                   ! m/day

           BioC(37)=   PrmBioC(37)/sedy0                   ! 1/day

           BioC(38)=   PrmBioC(38)/sedy0                   ! 1/day

           BioC(39)=   PrmBioC(39)                         ! 1/degC
           
           BioC(40)=   PrmBioC(40)                         
           
           BioC(41)=   PrmBioC(41)                                 
           
           BioC(42)=   PrmBioC(42)/sedy0                                 

           BioC(43)=   PrmBioC(43)/sedy0                    !   m/day
           BioC(44)=   PrmBioC(44)/sedy0                    !   m/day
           BioC(45)=   PrmBioC(45)/sedy0                    !   m/day
#if defined ECOCCO
           BioC(46)=   PrmBioC(46)/sedy0                    !  1/day
           BioC(47)=   PrmBioC(47)                          !  m**2/W        
           BioC(48)=   PrmBioC(48)*PrmREDF(1)*PrmREDF(6)    !  mmolN/m**3 
           BioC(49)=   PrmBioC(49)*PrmREDF(1)*PrmREDF(6)    !  mmolN/m**3 
           BioC(50)=   PrmBioC(50)*PrmREDF(2)*PrmREDF(6)    !  mmolP/m**3 
           BioC(51)=   PrmBioC(51)/sedy0                    !  1/day
           BioC(52)=   PrmBioC(52)/sedy0                    !  m/day
           BioC(53)=   PrmBioC(53)                          ! 
           BioC(54)=   PrmBioC(54)                          ! 
           BioC(55)=   PrmBioC(55)/sedy0                    !  1/day
#endif


          GI=PrmGI
*--------------- change units C mmol => C mg -----------------------------
c    Cmg=12.01*mmolC

*--------------- Redfiel molar ratio -----------------------------
      do i=1,10
      REDF(i) = PrmREDF(i)   ! N_C
      REDF(i+10) = 1./PrmREDF(i)   ! N_C
      end do



      return
      end

      end module m_ECOSM_bioini

